"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mailBuilderRouter = void 0;
const utils_1 = require("./utils");
const mailBuilderRouter = (route, app) => {
    app.logger.log('info', `mailbuilder: please open in your web browser: http://localhost:${app.env.get('PORT')}/mailbuilder`);
    const mailbuilderFolderPath = (0, utils_1.getMailBuilderCompiledClassesPath)(app);
    const mailBuilder = app.container.use('Adonis/Addons/MailBuilder');
    route
        .group(() => {
        route.get('/', async () => {
            const files = (await (0, utils_1.listFiles)(mailbuilderFolderPath)).filter((f) => (f.includes('.js') || f.includes('.ts')) && !f.includes('.map'));
            const mappedFiles = files.map((f) => `<a href="/mailbuilder/${f}"><h4>${f}</h4>`);
            return (0, utils_1.indexPageRender)(mappedFiles.join('\n') + (0, utils_1.livereloadScript)('/mailbuilder', ''));
        });
        route.get('/:name', async ({ params }) => {
            const MailBuilderClass = await Promise.resolve(`${`${mailbuilderFolderPath}/${params.name}`}`).then(s => __importStar(require(s)));
            // const MailBuilderClass: MailBuilderInterface = app.container.use(`App/MailBuilder/${params.name}`)
            const { html } = await mailBuilder.render(new MailBuilderClass.default({ name: '' }));
            return html + (0, utils_1.livereloadScript)('/mailbuilder', params.name);
        });
    })
        .prefix('mailbuilder');
};
exports.mailBuilderRouter = mailBuilderRouter;
